-module(n4u_mq).

-export([send/2, reg/1, reg/2, unreg/1]).


send(Pool, Message) -> gproc:send({p, l, Pool}, Message).


reg(Pool) -> reg(Pool, undefined).

reg(Pool, Value) ->
  case erlang:get({pool, Pool}) of
    undefined ->
      gproc:reg({p, l, Pool}, Value),
      erlang:put({pool, Pool}, Pool);
    
    _Defined -> skip
  end.


unreg(Pool) ->
  case erlang:get({pool,Pool}) of
    undefined -> skip;
    _Defined ->
      gproc:unreg({p, l, Pool}),
      erlang:erase({pool, Pool})
  end.

