-module(n4u_http).
-include_lib("n4u/include/n4u.hrl").

-export([info/3]).


%% ws.send(enc(tuple(atom('http'), bin(url), bin(method), bin(body), [])));


info(#http{} = Message, Req, State) ->
  wf:info(?MODULE, "Http Message: ~p", [Message]),
  Module = State#cx.module,
  Reply = try Module:event(Message)
  catch E:R:Stk ->
    wf:error(?MODULE, "Catch: ~p:~p~n~p", [E, R, Stk]),
    [E, R, Stk]
  end,
  {reply, wf:format({io, n4u_nitrogen:render_actions(erlang:get(actions)), Reply}), Req, State};

info(Message, Req, State) -> {unknown, Message, Req, State}.

