-module(n4u_pickle).

-export([pickle/1, depickle/1]).


% base64 encode/decode

pickle(Data) ->
  base64:encode(erlang:term_to_binary({Data, os:timestamp()}, [compressed])).


depickle(Serialized_Data) ->
  try
    {Data, _PickleTime} = erlang:binary_to_term(base64:decode(nitro:to_binary(Serialized_Data))),
    Data
  catch _:_ ->
    undefined
  end.

