-module(n4u_text).
-include_lib("n4u/include/n4u.hrl").

-export([info/3]).


info({text, Text} = Message, Req, State) when erlang:is_binary(Text) ->
  wf:info(?MODULE, "TEXT Message: ~p", [Message]),
  Module = State#cx.module,
  Resp = try Module:event(Message)
  catch E:R:Stk ->
    wf:error(?MODULE, "Catch: ~p:~p~n~p", [E, R, Stk]),
    <<"">>
  end,
  {reply, Resp, Req, State};


info(Message, Req, State) -> {unknown, Message, Req, State}.

